//+------------------------------------------------------------------+
//|                                                      ProjectName |
//|                                      Copyright 2012, CompanyName |
//|                                       http://www.companyname.net |
//+------------------------------------------------------------------+
/*
 *         
 * SmoothAlgorithms.mqh
 *   (): MetaTrader\\MQL5\Include
 */
//+------------------------------------------------------------------+
//|                                                      MARSICD.mq5 | 
//|                              Copyright  2011,   John Q. Aimsson | 
//|                                                aimsson@gmail.com | 
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, John Q. Aimsson"
#property link "aimsson@gmail.com"
//----   
#property version   "1.00"
//----     
#property indicator_separate_window
//----   
#property indicator_buffers 6 
//----     
#property indicator_plots   6

//+----------------------------------------------+
//|       |
//+----------------------------------------------+
#property indicator_minimum -100
#property indicator_maximum 100
//+----------------------------------------------+
//|     |
//+----------------------------------------------+
#property indicator_level1 70
#property indicator_level2 30
#property indicator_level3 -30
#property indicator_level4 -70
#property indicator_level5 50
#property indicator_level6 -50
#property indicator_levelcolor Gray
#property indicator_levelstyle STYLE_DASHDOTDOT
//+----------------------------------------------+
//|                  |
//+----------------------------------------------+
//----     
#property indicator_type1 DRAW_HISTOGRAM
//----      Gray
#property indicator_color1 Gray
//----   - 
#property indicator_style1 STYLE_SOLID
//----     2
#property indicator_width1 2
//----   
#property indicator_label1 "RSI"

//----     
#property indicator_type2 DRAW_LINE
//----      MediumOrchid
#property indicator_color2 MediumOrchid
//----   - -
#property indicator_style2 STYLE_DASHDOTDOT
//----     1
#property indicator_width2 1
//----   
#property indicator_label2 "Signal RSI"

//----     
#property indicator_type3   DRAW_LINE
//----       DodgerBlue 
#property indicator_color3 DodgerBlue
//----   -  
#property indicator_style3  STYLE_SOLID
//----     1
#property indicator_width3  1
//----   
#property indicator_label3  "Up RSI"

//----     
#property indicator_type4   DRAW_LINE
//----       DodgerBlue 
#property indicator_color4 DodgerBlue
//----   -  
#property indicator_style4  STYLE_SOLID
//----     1
#property indicator_width4  1
//----   
#property indicator_label4  "Dn RSI"

//----     
#property indicator_type5   DRAW_LINE
//----       Red 
#property indicator_color5 Red
//----   -  
#property indicator_style5  STYLE_SOLID
//----     1
#property indicator_width5  1
//----   
#property indicator_label5  "Up Signal RSI"

//----     
#property indicator_type6   DRAW_LINE
//----       Lime 
#property indicator_color6 Lime
//----   -  
#property indicator_style6  STYLE_SOLID
//----     1
#property indicator_width6  1
//----   
#property indicator_label6  "Dn Signal RSI"

//+----------------------------------------------+
//|    CXMA                        |
//+----------------------------------------------+
#include <SmoothAlgorithms.mqh> 
//+----------------------------------------------+

//----    CXMA   SmoothAlgorithms.mqh
CXMA XMA,AXMA,RXMA;
//+----------------------------------------------+
//|                        |
//+----------------------------------------------+
/*enum Smooth_Method -     SmoothAlgorithms.mqh
  {
   MODE_SMA_,  //SMA
   MODE_EMA_,  //EMA
   MODE_SMMA_, //SMMA
   MODE_LWMA_, //LWMA
   MODE_JJMA,  //JJMA
   MODE_JurX,  //JurX
   MODE_ParMA, //ParMA
   MODE_T3,    //T3
   MODE_VIDYA, //VIDYA
   MODE_AMA,   //AMA
  }; */
//+----------------------------------------------+
//|                    |
//+----------------------------------------------+
input Smooth_Method MAMethod=MODE_LWMA; // 
input uint ARSI_PERIOD=14;              // RSI A
input uint RRSI_PERIOD=14;              // RSI R
input uint AMA_PERIOD=5;                //  A
input uint RMA_PERIOD=5;                //  R
input uint sMAD_PERIOD=21;              //   
input uint MPhase=15; // ,
                      // JJMA    -100 ... +100,     ;
//  VIDIA   CMO,  AMA    
//+----------------------------------------------+

//----   ,    
//      
double ARSI_BUF[];
double RRSI_BUF[];
double AMA_BUF[];
double RMA_BUF[];
double Delta[];
double sMAD[];
//----      
int ARSI_Handle,RRSI_Handle;
//----      
int min_rates_total,min_rates_total1,min_rates_total2;
//+------------------------------------------------------------------+   
//| MARSICD indicator initialization function                        | 
//+------------------------------------------------------------------+ 
void OnInit()
  {
//----        
   min_rates_total1=int(MathMax(ARSI_PERIOD,RRSI_PERIOD));
   min_rates_total2=min_rates_total1+MathMax(XMA.GetStartBars(MAMethod,AMA_PERIOD,MPhase),XMA.GetStartBars(MAMethod,RMA_PERIOD,MPhase));
   min_rates_total=min_rates_total2+XMA.GetStartBars(MAMethod,sMAD_PERIOD,MPhase);

//----    RSI
   ARSI_Handle=iRSI(NULL,0,ARSI_PERIOD,PRICE_WEIGHTED);
   if(ARSI_Handle==INVALID_HANDLE) Print("      RSI");

//----    RSI
   RRSI_Handle=iRSI(NULL,0,RRSI_PERIOD,PRICE_WEIGHTED);
   if(RRSI_Handle==INVALID_HANDLE) Print("      RSI");

//----      
   SetIndexBuffer(0,Delta,INDICATOR_DATA);
//----      
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,min_rates_total);
//----   ,      
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,EMPTY_VALUE);
//----          
   ArraySetAsSeries(Delta,true);

//----      
   SetIndexBuffer(1,sMAD,INDICATOR_DATA);
//----      
   PlotIndexSetInteger(1,PLOT_DRAW_BEGIN,min_rates_total);
//----   ,      
   PlotIndexSetDouble(1,PLOT_EMPTY_VALUE,EMPTY_VALUE);
//----          
   ArraySetAsSeries(sMAD,true);

//----      
   SetIndexBuffer(2,RRSI_BUF,INDICATOR_DATA);
//----      
   PlotIndexSetInteger(2,PLOT_DRAW_BEGIN,min_rates_total);
//----   ,      
   PlotIndexSetDouble(2,PLOT_EMPTY_VALUE,EMPTY_VALUE);
//----          
   ArraySetAsSeries(RRSI_BUF,true);

//----      
   SetIndexBuffer(3,ARSI_BUF,INDICATOR_DATA);
//----      
   PlotIndexSetInteger(3,PLOT_DRAW_BEGIN,min_rates_total);
//----   ,      
   PlotIndexSetDouble(3,PLOT_EMPTY_VALUE,EMPTY_VALUE);
//----          
   ArraySetAsSeries(ARSI_BUF,true);

//----      
   SetIndexBuffer(4,RMA_BUF,INDICATOR_DATA);
//----      
   PlotIndexSetInteger(4,PLOT_DRAW_BEGIN,min_rates_total);
//----   ,      
   PlotIndexSetDouble(4,PLOT_EMPTY_VALUE,EMPTY_VALUE);
//----          
   ArraySetAsSeries(RMA_BUF,true);

//----      
   SetIndexBuffer(5,AMA_BUF,INDICATOR_DATA);
//----      
   PlotIndexSetInteger(5,PLOT_DRAW_BEGIN,min_rates_total);
//----   ,      
   PlotIndexSetDouble(5,PLOT_EMPTY_VALUE,EMPTY_VALUE);
//----          
   ArraySetAsSeries(AMA_BUF,true);

//----      
   string shortname="MARSICD";
//---           
   IndicatorSetString(INDICATOR_SHORTNAME,shortname);

//---     
   IndicatorSetInteger(INDICATOR_DIGITS,_Digits+1);
//----  
  }
//+------------------------------------------------------------------+ 
//| MARSICD iteration function                                       | 
//+------------------------------------------------------------------+ 
int OnCalculate(
                const int rates_total,    //       
                const int prev_calculated,//       
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[]
                )
  {
//----       
   if(BarsCalculated(ARSI_Handle)<rates_total
      || BarsCalculated(RRSI_Handle)<rates_total
      || rates_total<min_rates_total) return(0);

//----   
   int limit,to_copy,bar,maxbar1,maxbar2;

//----    first    
   if(prev_calculated>rates_total || prev_calculated<=0) //      
      limit=rates_total-1; //      
   else limit=rates_total-prev_calculated; //      

   to_copy=limit+1;
//----      
   if(CopyBuffer(ARSI_Handle,0,0,to_copy,ARSI_BUF)<=0) return(0);
   if(CopyBuffer(RRSI_Handle,0,0,to_copy,RRSI_BUF)<=0) return(0);

   maxbar1=rates_total-1-min_rates_total1;
   maxbar2=maxbar1-min_rates_total2;

//----    
   for(bar=limit; bar>=0 && !IsStopped(); bar--)
     {
      RRSI_BUF[bar]*=(-1);
      RRSI_BUF[bar]+=100;
      AMA_BUF[bar]=AXMA.XMASeries(maxbar1,prev_calculated,rates_total,MAMethod,MPhase,AMA_PERIOD,ARSI_BUF[bar],bar,true);
      RMA_BUF[bar]=RXMA.XMASeries(maxbar1,prev_calculated,rates_total,MAMethod,MPhase,RMA_PERIOD,RRSI_BUF[bar],bar,true);
      Delta[bar]=AMA_BUF[bar]-RMA_BUF[bar];
      sMAD[bar]=XMA.XMASeries(maxbar2,prev_calculated,rates_total,MAMethod,MPhase,sMAD_PERIOD,Delta[bar],bar,true);
     }
//----     
   return(rates_total);
  }
//+------------------------------------------------------------------+
